unsigned char KeyScan(void)
{
	R1=R2=R3=R4=0;
	C1=C2=C3=1;
	while(1)
	{
		MSDelay(20); //This is to gen intentional delay to avoid key debouncing.
    if((C1==0||C2==0||C3==0))	//Is there any change,meaning any key is pressed?
		{
			//We will be here if some -key is pressed.
			R1=0;R2=R3=R4=1;
			if(C1==0)
				return '1';//1=1; '1'=0x31-(49)in decimal.
			if(C2==0)
				return '2';
			if(C3==0)
				return '3';

			R2=0;R1=R3=R4=1;
			if(C1==0)
				return '4';
			if(C2==0)
				return '5';
			if(C3==0)
				return '6';

			R3=0;R1=R2=R4=1;
			if(C1==0)
				return '7';
			if(C2==0)
				return '8';
			if(C3==0)
				return '9';
			
			R4=0;R1=R2=R3=1;
			if(C1==0)
				return '*';	 //ASCII(*)=0x2A
			if(C2==0)
				return '0';
			if(C3==0)
				return '#';		//ASCII(#)=0x23			
		}
	}
}